#![allow(non_camel_case_types)]
#![allow(non_upper_case_globals)]
#[derive(Debug, Clone, Copy, PartialEq, Eq, Hash)]
#[repr(i32)]
pub enum ELicenseType {
    NoLicense = 0,
    SinglePurchase = 1,
    SinglePurchaseLimitedUse = 2,
    RecurringCharge = 3,
    RecurringChargeLimitedUse = 4,
    RecurringChargeLimitedUseWithOverages = 5,
    RecurringOption = 6,
    LimitedUseDelayedActivation = 7,
}

impl ELicenseType {
    pub fn from_i32(val: i32) -> Option<Self> {
        match val {
            x if x == Self::NoLicense as i32 => Some(Self::NoLicense),
            x if x == Self::SinglePurchase as i32 => Some(Self::SinglePurchase),
            x if x == Self::SinglePurchaseLimitedUse as i32 => Some(Self::SinglePurchaseLimitedUse),
            x if x == Self::RecurringCharge as i32 => Some(Self::RecurringCharge),
            x if x == Self::RecurringChargeLimitedUse as i32 => Some(Self::RecurringChargeLimitedUse),
            x if x == Self::RecurringChargeLimitedUseWithOverages as i32 => Some(Self::RecurringChargeLimitedUseWithOverages),
            x if x == Self::RecurringOption as i32 => Some(Self::RecurringOption),
            x if x == Self::LimitedUseDelayedActivation as i32 => Some(Self::LimitedUseDelayedActivation),
            _ => None,
        }
    }
}
